; This demo is a fileopen dialogue with preview.
; You will need to get a copy of DOSLIB.


(DEFUN C:DEMO(/ path dir dcl_id file filelist line i drivelist dirlist directory result)

; your path here, that's where you want to copy the following files
; demo.lsp
; demo.dcl
; linnet21.exe
 (SETQ path "C:\\Linnet Demo\\")

; load DOSLIB (your version here)
 (IF (NULL dos_about) (ARXLOAD "DOSLIB14"))

;remove temporary files
 (dos_delete (STRCAT path "DEMO.SLD"))

; get list of drives
 (SETQ drivelist (dos_drives))

 (SETQ dcl_id (LOAD_DIALOG (STRCAT path "DEMO.DCL"))) 
 (IF (NOT (NEW_DIALOG "demo" dcl_id)) (PROGN (ALERT "DCL missing") (EXIT)))

 (ACTION_TILE "itemlist" "(click (get_tile \"itemlist\"))")
 (ACTION_TILE "dirlist" "(dirclick (get_tile \"dirlist\"))")
 (ACTION_TILE "drives" "(driveclick (get_tile \"drives\"))")
 (ACTION_TILE "accept" "(PROGN (SETQ result (STRCAT directory (NTH (ATOI (GET_TILE \"itemlist\")) filelist)))(DONE_DIALOG))")
 (ACTION_TILE "cancel" "(SETQ result NIL)")

 (START_LIST "drives")
  (FOREACH n drivelist (ADD_LIST n))
 (END_LIST)
 (SETQ i (ITOA (- (LENGTH drivelist) (LENGTH (MEMBER (dos_drive) drivelist)))))
 (SET_TILE "drives" i)
 (driveclick i)

 (START_DIALOG)
 (UNLOAD_DIALOG dcl_id)
 result
)

(DEFUN driveclick (d)
 (SETQ directory (STRCAT (NTH (ATOI (GET_TILE "drives")) drivelist) "\\"))
 (dirclick "")
)

(DEFUN dirclick(d / line file)
 (MODE_TILE "dirlist" 1) 
 (MODE_TILE "drives" 1) 
 (MODE_TILE "itemlist" 1) 
 (MODE_TILE "accept" 1) 
 (MODE_TILE "cancel" 1) 
 (IF (/= d "")
  (IF (= (NTH (ATOI d) dirlist) "..")
   (PROGN
    (SETQ directory (SUBSTR directory 1 (1- (STRLEN directory))))
    (WHILE (/= (SUBSTR directory (STRLEN directory) 1) "\\")
     (SETQ directory (SUBSTR directory 1 (1- (STRLEN directory))))
    )
   )
   (SETQ directory (STRCAT directory (NTH (ATOI d) dirlist) "\\"))
  )
 )

 (SETQ dirlist (dos_subdir directory))
 (IF dirlist (SETQ dirlist (ACAD_STRLSORT dirlist)))
 (START_LIST "dirlist")
  (FOREACH n dirlist (ADD_LIST n))
 (END_LIST)

 (SETQ filelist (APPEND (dos_dir (STRCAT directory "*.DWG")) (dos_dir (STRCAT directory "*.BAK"))))
 (IF filelist (SETQ filelist (ACAD_STRLSORT filelist)))
 (START_LIST "itemlist")
  (FOREACH n filelist (ADD_LIST n))
 (END_LIST)

 (SET_TILE "dir" directory)
 (IF filelist
  (PROGN
   (click "0")
   (SET_TILE "itemlist" "0")
  )
 )

 (MODE_TILE "dirlist" 0) 
 (MODE_TILE "drives" 0) 
 (MODE_TILE "itemlist" 0) 
 (MODE_TILE "accept" 0) 
 (MODE_TILE "cancel" 0) 
)

(DEFUN click (n / x y file attr)
 (MODE_TILE "dirlist" 1) 
 (MODE_TILE "drives" 1) 
 (MODE_TILE "itemlist" 1) 
 (MODE_TILE "accept" 1) 
 (MODE_TILE "cancel" 1) 

; create slide
; (alert (STRCAT "\"" path "linnet20.exe\" \"" directory (NTH (ATOI n) filelist) "\" \"" path "DEMO.SLD\""))
 (startapp (STRCAT "\"" path "linnet20.exe\"") (STRCAT "\"" directory (NTH (ATOI n) filelist) "\" \"" path "DEMO.SLD\""))
; (alert "over")
; (SETQ attr (CDAR (dos_attrib (STRCAT path "DEMO.SLD"))))
  (SETQ attr (SUBSTR (NTH 3 (dos_file (STRCAT path "DEMO.SLD"))) 4 2))

 (SET_TILE "ver"
  (COND 
   ((= attr "10") "AutoCAD R10 DWG")
   ((= attr "12") "AutoCAD R12 DWG")
   ((= attr "13") "AutoCAD R13 DWG")
   ((= attr "14") "AutoCAD R14 DWG")
   ((= attr "15") "AutoCAD R2000 DWG")
   (T "not a valid drawing")
  )
 )

 (SETQ x (DIMX_TILE "preview")
       y (DIMY_TILE "preview"))

; load slide
 (START_IMAGE "preview")
  (FILL_IMAGE 0 0 x y -2)
  (SLIDE_IMAGE 0 0 x y (STRCAT "\"" path "DEMO.SLD\""))
 (END_IMAGE)
 (dos_delete (STRCAT path "DEMO.SLD"))

 (MODE_TILE "dirlist" 0) 
 (MODE_TILE "drives" 0) 
 (MODE_TILE "itemlist" 0) 
 (MODE_TILE "accept" 0) 
 (MODE_TILE "cancel" 0) 
)

(C:DEMO)
